s         ::=  ws grammar ws                  => "gram"
ws       !::=  w**
grammar   ::=  r+/ws => "grammar"
r         ::=  word  ^"::=" alternatives /ws
            |  word ^"!::=" alternatives /ws

ec        ::=  [~\]\\\-\~] | escaped

alternatives  ::=  equiAlt   +/ (ws ">" ws)
equiAlt       ::=  conjuncts +/ (ws "|" ws)          => "alternatives"

sequence    ::= Es
              > Es ^"/" E   /ws
Es          ::= E+
//es          ::= E+/ws

conjuncts   ::=  rewrite
              |  rewrite ^"&"  sequence   /ws
              |  rewrite ^"&~" sequence   /ws

rewrite  ::=  sequence                  /ws        => "rewrite"
           |  sequence ^"=>" word       /ws
           |  sequence ^"=>" quoted     /ws
           |  sequence  "=>" "()"       /ws        => "wrap"

range    ::= ec => "range0" | ec ^"-" ec      => "range0"
E        ::= word                             => "nonTerminalY"
           |    [(][)] => "epsilon"
           |    ^"{" alternatives "}"
           |     "[" [\~]?  range* "]"        => "range"
           |  E ^"*/" E
           |  E ^"+/" E
           |  E ^"?"
           |  E ^"~/~"

           |  E ^"-"  E

           |    ^"!" E
           |     "^" quoted => "care"
           |    ^"`" E
           |  E ^"#"
           |  quoted                        => "literal"

           |  (E ^"**" > E ^"*")
           |  (E ^"++" > E ^"+")

           |     "(" word ^")"
           >    ^"(" alternatives ")"

w       !::= " "
           | "//" [~\n]* "\n"
           | "\n"
           | "\r"
an       ::= [a-zA-Z0-9_]
word     ::= an++                           => "sify"
quoted   ::= "\"" ([~\"\\] | escaped)* "\"" => "sify"
escaped  ::= "\\n" => "\n"
           | "\\r" => "\r"
           | "\\" [~nr]
